Subject: Re* manpage for git-pull mentions a non-valid option -m in a comment

From: Junio C Hamano <[email-masked]>
Date: Tue, 14 Jan 2014 10:26:21 -0800

Ivan Zakharyaschev <[email-masked]> writes:

> Hello!
>
> git-1.8.4.4
>
> The manpage for git-pull mentions -m in a comment:
>
> --edit, -e, --no-edit
> Invoke an editor before committing successful mechanical merge to further edit
> the auto-generated merge message, so that the user can explain and justify the
> merge. The --no-edit option can be used to accept the auto-generated message
> (this is generally discouraged). The --edit (or -e) option is still useful if
> you are giving a draft message with the -m option from the command line and
> want to edit it in the editor.
>
> but it is not accepted actually:

I do not think "git pull" ever had the "-m <message>" option; what
you are seeing probably is a fallout from attempting to share the
documentation pieces between "git pull" and "git merge" too
agressively without proofreading.

It seems that there are two issues; here is an untested attempt to
fix.

-- >8 --
Subject: Documentaiotn: exclude irrelevant options from "git pull"

10eb64f5 (git pull manpage: don't include -n from fetch-options.txt,
2008-01-25) introduced a way to exclude some parts of included
source when building git-pull documentation, and later 409b8d82
(Documentation/git-pull: put verbosity options before merge/fetch
ones, 2010-02-24) attempted to use the mechanism to exclude some
parts of merge-options.txt when used from git-pull.txt.

However, the latter did not have an intended effect, because the
macro "git-pull" used to decide if the source is included in
git-pull documentation were defined a bit too late.

Define the macro before it is used to fix this.

Even though "--[no-]edit" can be used with "git pull", the
explanation of the interaction between this option and the "-m"
option does not make sense within the context of "git pull".  Use
the same conditional inclusion mechanism to remove this part from
"git pull" documentation, while keeping it for "git merge".

Reported-by: Ivan Zakharyaschev
Signed-off-by: Junio C Hamano <[email-masked]>
---

 Documentation/git-pull.txt      | 4 ++--
 Documentation/merge-options.txt | 9 ++++++---
 2 files changed, 8 insertions(+), 5 deletions(-)

diff --git a/Documentation/git-pull.txt b/Documentation/git-pull.txt
index 6083aab..200eb22 100644
--- a/Documentation/git-pull.txt
+++ b/Documentation/git-pull.txt
@@ -99,10 +99,10 @@ must be given before the options meant for 'git fetch'.
 Options related to merging
 ~~~~~~~~~~~~~~~~~~~~~~~~~~
 
-include::merge-options.txt[]
-
 :git-pull: 1
 
+include::merge-options.txt[]
+
 -r::
 --rebase[=false|true|preserve]::
 	When true, rebase the current branch on top of the upstream
diff --git a/Documentation/merge-options.txt b/Documentation/merge-options.txt
index afba8d4..e134315 100644
--- a/Documentation/merge-options.txt
+++ b/Documentation/merge-options.txt
@@ -14,9 +14,12 @@ inspect and further tweak the merge result before committing.
 	further edit the auto-generated merge message, so that the user
 	can explain and justify the merge. The `--no-edit` option can be
 	used to accept the auto-generated message (this is generally
-	discouraged). The `--edit` (or `-e`) option is still useful if you are
-	giving a draft message with the `-m` option from the command line
-	and want to edit it in the editor.
+	discouraged).
+ifndef::git-pull[]
+The `--edit` (or `-e`) option is still useful if you are
+giving a draft message with the `-m` option from the command line
+and want to edit it in the editor.
+endif::git-pull[]
 +
 Older scripts may depend on the historical behaviour of not allowing the
 user to edit the merge log message. They will see an editor opened when